<?Lassoscript
// Last modified 6/23/08 by ECL, Landmann InterActive
// For LDC 08 presentation

// Tagname			Debug
// Description		Creates a debug container
// Author			Eric Landmann
// Date				6/23/2008
// Usage			Debug;
//						'SomeVar = ' $SomeVar '<br>\n';
//					/Debug;
// Expected Output	If $xDebug = Y, contents of debug container will be output
//					If $xDebug != Y, nothing will output
If: !(Lasso_TagExists:'Debug');
	Define_Tag: 'Debug',
		-Container;

		Local('Start') = ('<p class="debug"><strong>' + (Response_Filepath) + '</strong><br>\n');
		Local('End') = '</p>\n';
		If: (Var:'xDebug') == 'Y';
			Local('Output') = (#Start) + (Run_Children) + (#End);
		Else;
			Local('Output') = ('<!-- Debugging is off -->\n');
		/If;
		Return: (Encode_Smart:#Output);

	/Define_Tag;

	Log_Critical: 'Custom Tag Loaded - Debug';

/If;

/*
// Testing
Var:'xDebug' = 'Y';
Var:'SomeVar' = 'booha';

Debug;
	'SomeVar = ' $SomeVar '<br>\n';
/Debug;
*/
?>
